VERSION 4.00
Begin VB.Form frmWord 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Word"
   ClientHeight    =   4110
   ClientLeft      =   1050
   ClientTop       =   1755
   ClientWidth     =   7590
   Height          =   4800
   Icon            =   "FRMWORD.frx":0000
   Left            =   990
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   4110
   ScaleWidth      =   7590
   Top             =   1125
   Visible         =   0   'False
   Width           =   7710
   Begin VB.OLE Word 
      Class           =   "Word.Document.6"
      Height          =   4065
      Left            =   0
      OleObjectBlob   =   "FRMWORD.frx":030A
      TabIndex        =   0
      Top             =   0
      Width           =   7575
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      NegotiatePosition=   1  'Left
      Begin VB.Menu mnuFileItems 
         Caption         =   "&New"
         Index           =   1
      End
      Begin VB.Menu mnuFileItems 
         Caption         =   "&Open..."
         Index           =   2
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileItems 
         Caption         =   "&Save As..."
         Index           =   3
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileItems 
         Caption         =   "-"
         Index           =   4
      End
      Begin VB.Menu mnuFileItems 
         Caption         =   "&Print..."
         Index           =   5
         Shortcut        =   ^P
      End
      Begin VB.Menu mnuFileItems 
         Caption         =   "-"
         Index           =   6
      End
      Begin VB.Menu mnuFileItems 
         Caption         =   "E&xit"
         Index           =   7
      End
   End
   Begin VB.Menu mnuObject 
      Caption         =   "&Object"
      NegotiatePosition=   2  'Middle
      Begin VB.Menu mnuObjectItems 
         Caption         =   "Cu&t"
         Enabled         =   0   'False
         Index           =   1
         Shortcut        =   ^X
      End
      Begin VB.Menu mnuObjectItems 
         Caption         =   "&Copy"
         Enabled         =   0   'False
         Index           =   2
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuObjectItems 
         Caption         =   "&Paste"
         Enabled         =   0   'False
         Index           =   3
         Shortcut        =   ^V
      End
      Begin VB.Menu mnuObjectItems 
         Caption         =   "Paste &Special..."
         Enabled         =   0   'False
         Index           =   4
      End
      Begin VB.Menu mnuObjectItems 
         Caption         =   "&Delete"
         Index           =   5
         Shortcut        =   {DEL}
      End
      Begin VB.Menu mnuObjectItems 
         Caption         =   "-"
         Index           =   6
      End
      Begin VB.Menu mnuObjectItems 
         Caption         =   "Close Object"
         Index           =   7
      End
   End
   Begin VB.Menu mnuWindow 
      Caption         =   "&Window"
      NegotiatePosition=   3  'Right
      WindowList      =   -1  'True
      Begin VB.Menu mnuWindowItems 
         Caption         =   "&Cascade"
         Index           =   1
      End
      Begin VB.Menu mnuWindowItems 
         Caption         =   "Tile &Horizontal"
         Index           =   2
      End
      Begin VB.Menu mnuWindowItems 
         Caption         =   "Tile &Vertical"
         Index           =   3
      End
      Begin VB.Menu mnuWindowItems 
         Caption         =   "&Arrange Icons"
         Index           =   4
      End
   End
End
Attribute VB_Name = "frmWord"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'*********************************************************************
' FRMWORD.FRM - MDI Child form with a OLE container control.
'*********************************************************************
Option Explicit
'*********************************************************************
' This insures that the Word object is always the same size as the
' client area of the window.
'*********************************************************************
Private Sub Form_Resize()
    Word.Move 0, 0, ScaleWidth, ScaleHeight
End Sub
'*********************************************************************
' Handles clicks from the File Submenu
'*********************************************************************
Private Sub mnuFileItems_Click(Index As Integer)
    On Error Resume Next
    Select Case Index
        Case 1 'New
            If WordWindows <= MAX_WINDOWS Then
                WordWindows = WordWindows + 1
                WinWord(WordWindows - 1).Caption = Me.Caption & " -" _
                                                & Str$(WordWindows + 1)
            End If
        Case 2 'Open...
            mdiOLE!cdlg.InitDir = App.Path
            mdiOLE!cdlg.Flags = cdlOFNFileMustExist + cdlOFNHideReadOnly _
                                + cdlOFNNoChangeDir
            mdiOLE!cdlg.ShowOpen
            If Err = cdlCancel Then Exit Sub
            Open (mdiOLE!cdlg.FileName) For Binary As #1
                Word.ReadFromFile 1
            Close #1
        Case 3 'Save As...
            mdiOLE!cdlg.Flags = cdlOFNOverwritePrompt + cdlOFNNoChangeDir
            mdiOLE!cdlg.ShowSave
            If Err = cdlCancel Then Exit Sub
            Open (mdiOLE!cdlg.FileName) For Binary As #1
                Word.SaveToFile 1
            Close #1
        Case 5
            mdiOLE!cdlg.Flags = cdlPDDisablePrintToFile + cdlPDNoPageNums _
                                + cdlPDNoSelection
            mdiOLE!cdlg.ShowPrinter
            If Err = cdlCancel Then Exit Sub
            With Word
                .DoVerb vbOLEShow
                Printer.PaintPicture .picture, 0, 0
                .Close
                Printer.EndDoc
            End With
        Case 7 'Exit
            Unload mdiOLE
    End Select
End Sub
'*********************************************************************
' Updates the Object Submenu's enabled status
'*********************************************************************
Private Sub mnuObject_Click()
    mnuObjectItems(1).Enabled = Not (Word.OLEType = vbOLENone)
    mnuObjectItems(2).Enabled = Not (Word.OLEType = vbOLENone)
    mnuObjectItems(3).Enabled = Word.PasteOK
    mnuObjectItems(4).Enabled = Word.PasteOK
    mnuObjectItems(5).Enabled = Not (Word.OLEType = vbOLENone)
End Sub
'*********************************************************************
' Handles clicks from the Object Submenu
'*********************************************************************
Private Sub mnuObjectItems_Click(Index As Integer)
    Select Case Index
        Case 1 'Cut
            With Word
                .DoVerb vbOLEShow
                .Copy
                .Close
                .Delete
            End With
        Case 2 'Copy
            With Word
                .DoVerb vbOLEShow
                .Copy
            End With
        Case 3 'Paste
            Word.Paste
        Case 4 'Paste Special...
            Word.PasteSpecialDlg
        Case 5 'Delete
            Word.Delete
        Case 7 'Close Object
            Word.Close
    End Select
End Sub
'*********************************************************************
' Updates the status bar
'*********************************************************************
Private Sub Word_MouseMove(Button As Integer, Shift As Integer, X As _
                                                  Single, Y As Single)
    UpdateStatus mdiOLE!lblStatus, "Double click to edit this object in Word"
End Sub
'*********************************************************************
' Handles clicks from the Window Submenu
'*********************************************************************
Private Sub mnuWindowItems_Click(Index As Integer)
    mdiOLE.Arrange Index - 1
End Sub
'*********************************************************************
' Displays a Open dialog, and loads the file into a OLE Container
'*********************************************************************
Private Sub OLEOpenFile(OLEObject As OLE)
Dim iFile%
    mdiOLE!cdlg.InitDir = App.Path
    mdiOLE!cdlg.Flags = cdlOFNFileMustExist + cdlOFNHideReadOnly _
                        + cdlOFNNoChangeDir
    mdiOLE!cdlg.ShowOpen
    If Err = cdlCancel Then Exit Sub
    iFile = FreeFile
    Open (mdiOLE!cdlg.FileName) For Binary As iFile
        OLEObject.ReadFromFile iFile
    Close iFile
End Sub
'*********************************************************************
' Displays a Save As dialog, and saves the contents of a OLE Container
'*********************************************************************
Private Sub OLESaveFile(OLEObject As OLE)
Dim iFile%
    mdiOLE!cdlg.Flags = cdlOFNOverwritePrompt + cdlOFNNoChangeDir
    mdiOLE!cdlg.ShowSave
    If Err = cdlCancel Then Exit Sub
    iFile = FreeFile
    Open (mdiOLE!cdlg.FileName) For Binary As iFile
        OLEObject.SaveToFile iFile
    Close iFile
End Sub
